/***********************************************************************
 * This file is part of module_imagepreview.
 *
 * module_imagepreview is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * module_imagepreview is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with module_imagepreview.  If not, see <http://www.gnu.org/licenses/>
 * 
 * 
 * Copyright (C) 2013, Dominik Rueß; info@dominik-ruess.de
 **********************************************************************/

#ifndef IMAGEVIEWDELEGATE_H
#define IMAGEVIEWDELEGATE_H

#include <QItemDelegate>
#include "imagedata.h"
#include <imageviewmodel.h>

#include <QProgressBar>
#include <QWidget>
#include <QTableView>

class ImageViewDelegate : public QItemDelegate
{
    Q_OBJECT
        public:
    explicit ImageViewDelegate(QWidget *parent = 0);
    virtual ~ImageViewDelegate() {}

    virtual QWidget *createEditor(QWidget *parent,
                                  const QStyleOptionViewItem &option,
                                  const QModelIndex &index) const;

    virtual void setEditorData(QWidget *editor, const QModelIndex &index) const;
    virtual void setModelData(QWidget *editor, QAbstractItemModel *model,
                              const QModelIndex &index) const;

    virtual void updateEditorGeometry(QWidget *editor,
                                      const QStyleOptionViewItem &option,
                                      const QModelIndex &index) const;

    virtual QSize sizeHint ( const QStyleOptionViewItem & option,
                             const QModelIndex & index ) const;
    virtual void paint ( QPainter * painter,
                         const QStyleOptionViewItem & option,
                         const QModelIndex & index ) const;

    void setThumbnailSize(int size) { _thumbnailsize = size; }

    void setParent(QTableView* parent) {_parent = parent; }

  signals:

    public slots:

  protected:
    int _thumbnailsize;

    QTableView* _parent;

};

#endif // IMAGEVIEWDELEGATE_H
