/***********************************************************************
 * This file is part of module_imageviewer.
 *
 * module_imageviewer is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * module_imageviewer is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with module_imageviewer.  If not, see <http://www.gnu.org/licenses/>
 * 
 * 
 * Copyright (C) 2013, Dominik Rueß; info@dominik-ruess.de
 **********************************************************************/

#ifndef IMAGEVIEWERLOADER_H
#define IMAGEVIEWERLOADER_H

#include <QThread>
#include <QString>
#include <QMutex>

#include "smartpointers.h"

class ImageViewerLoader : public QThread
{
    Q_OBJECT
public:
    explicit ImageViewerLoader(const QString Filename,
                               QObject *parent = 0);

    ~ImageViewerLoader();

    void deleteInstance();

signals:
    void doneLoading(const MiscTools::pQImage&, const QString&);

protected:
    void run();


private:

    const QString _file;
    const QSize _imSize;
};

#endif // IMAGEVIEWERLOADER_H
