/***********************************************************************
 * This file is part of module_misc.
 *
 * module_misc is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * module_misc is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with module_misc.  If not, see <http://www.gnu.org/licenses/>
 * 
 * 
 * Copyright (C) 2013, Dominik Rueß; info@dominik-ruess.de
 **********************************************************************/

#ifndef FILENAMENUMBERING_H
#define FILENAMENUMBERING_H

#include <QVector>
#include <QVariant>
#include <QDateTime>

#include "filenamenumbering_pre.h"

namespace MiscTools
{

    class FilenameNumbering : public FilenameNumbering_PRE
{
    friend class FilenameNumberingTests;
 private:
        FilenameNumbering();
public:



    static bool mergeAndReorderFiles(
            const QStringList& existingFiles,
            const QVector<QDateTime>& newFileTimes,
            const QString& taggedFileName,
            const QVector<QPair<QString, QString> >& tagsAndDateMap,
            QVector<QPair<int, int> >& newlySortedList,
            QVector<DT>& fileDatesExisting);
    /**
      * assumes pre-sorted inputs
      */
    static QVector<DT> getExistingFileTimeForCopyMerge(
            const QStringList &filenames,
            const QString& taggedFileName,
            const QVector<QPair<QString, QString> >& tagsAndDateMap,
            QString &datePattern);

};

} // namespace MiscTools

#endif // FILENAMENUMBERING_H
