/***********************************************************************
 * This file is part of module_misc.
 *
 * module_misc is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * module_misc is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with module_misc.  If not, see <http://www.gnu.org/licenses/>
 * 
 * 
 * Copyright (C) 2013, Dominik Rueß; info@dominik-ruess.de
 **********************************************************************/

#ifndef IMAGEBUTTON_H
#define IMAGEBUTTON_H

#include <QWidget>
#include <QSize>
#include <QPushButton>

class QIcon;

namespace MiscTools
{

class ImageButton : public QPushButton
{
    Q_OBJECT

public:
    ImageButton(const int addHorizontal = 15, QWidget *parent = NULL);

    void setPixmap(const QString& filename, const int margin);

    void setDone(const QString& filename, const int margin);

    void setHorizontalSizeHintAdd(const int);

protected:
    virtual void paintEvent( QPaintEvent* event );

    virtual QSize minimumSizeHint() const;
    virtual QSize sizeHint() const;

private:
    QIcon _icon;
    QIcon _iconDone;
    int _margin;
    int _addHorizontal;
};


//class ImageButton : public QAbstractButton {
//Q_OBJECT
//public:
//...
//    void setPixmap( const QPixmap& pm ) { m_pixmap = pm; update(); }
//    QSize sizeHint() const { return m_pixmap.size(); }
//protected:
//    void paintEvent( QPaintEvent* e ) {
//        QPainter p( this );
//        p.drawPixmap( 0, 0, m_pixmap );
//    }
//};

} // end namespace MiscTools

#endif // IMAGEBUTTON_H
