/***********************************************************************
 * This file is part of pivot.
 *
 * pivot is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * pivot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with pivot.  If not, see <http://www.gnu.org/licenses/>
 * 
 * 
 * Copyright (C) 2013, Dominik Rueß; info@dominik-ruess.de
 **********************************************************************/

#ifndef COPYASSISTANT_H
#define COPYASSISTANT_H

#include <QObject>

enum CurrentCopyState
{
    CopyStateStart,
    CopyStateLoading,
    CopyStateAdaptTimes,
    CopyStateAlbums,
    CopyStateKeepSubdirs,
    CopyStateCopyPreview,
    CopyStateCopy
};

class CopyAssistant : public QObject
{
    Q_OBJECT
public:
    explicit CopyAssistant(QObject *parent = 0);

signals:
    void loadFiles();
    void adaptTimes();
    void manageAlbums();
    void keepSubdirectories();
    void copyPreview();
    void copy();

public slots:
    void restart(QWidget* parent);
    void doneNextStep(QWidget* parent);

private:
    CurrentCopyState _state;
};

#endif // COPYASSISTANT_H
