/***********************************************************************
 * This file is part of pivot.
 *
 * pivot is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * pivot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with pivot.  If not, see <http://www.gnu.org/licenses/>
 * 
 * 
 * Copyright (C) 2013, Dominik Rueß; info@dominik-ruess.de
 **********************************************************************/

#ifndef KEEPDIRECTORIESDIALOG_H
#define KEEPDIRECTORIESDIALOG_H

#include <QDialog>
#include <QStringList>
#include <QPair>
#include "directorydelegate.h"

namespace Ui {
    class KeepDirectoriesDialog;
}

class KeepDirectoriesDialog : public QWidget
{
    Q_OBJECT

public:
    explicit KeepDirectoriesDialog(QWidget *parent = 0);
    ~KeepDirectoriesDialog();

    void setDirectories(const QStringList& directories);

    QList<QPair<QString, QString> > getDirectoryMap();

    void loadSettings();


public slots:
    void showInfo();

    void _on_pushButton_finish_clicked();

signals:
    void doneEditing();

private slots:
    void on_pushButton_add_clicked();

    void on_toolButton_delete_clicked();

private:

    Ui::KeepDirectoriesDialog *ui;

    QStringList _directories;

    DirectoryDelegate _directoryDelegate;

    bool _infoHasBeenShown;
};

#endif // KEEPDIRECTORIESDIALOG_H
