/***********************************************************************
 * This file is part of pivot.
 *
 * pivot is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * pivot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with pivot.  If not, see <http://www.gnu.org/licenses/>
 * 
 * 
 * Copyright (C) 2013, Dominik Rueß; info@dominik-ruess.de
 **********************************************************************/

#ifndef TOOLS_H
#define TOOLS_H

#include <QString>
#include <QDir>
#include <QSqlDatabase>
#include <QApplication>

#include <progressdialog.h>
#include "imagedataextended.h"
#include "eventselectionassistant.h"

class Tools
{
public:

    static QList<ImageDataPtr> findFiles(const QString& dir,
                                         const bool tryFindAlreadyCopied,
                                         const QSqlDatabase* db,
                                         const QDir::Filters& filter = QDir::NoFilter,
                                         ProgressDialog* progress = NULL);

    static QList<ImageDataPtr> sortItems(const QList<ImageDataPtr>& input,
                                         const QStringList&,
                                         const bool tryToUseMetadata,
                                         const bool tryToUseBasename,
                                         const bool tryToUseNeighbours,
                                         const bool tryToUseFileTime,
                                         QList<ImageDataPtr>& discarded,
                                         QList<QDir>& resultDirs);

    static void provideInfo(QWidget* parent,
                            const QString& headline,
                            const QString& text,
                            const QString& settingsValue,
                            const QString& showAgain = qApp->translate("tools", "Show hint in future"),
                            const int width = 800,
                            const int minWidth = 600);

//    static int assistantDialog(QWidget *parent,
//                               const QString &headline,
//                               const QString &text,
//                               const QStringList options);


private:
};


#endif // TOOLS_H
