/***********************************************************************
 * This file is part of pivot.
 *
 * pivot is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * pivot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with pivot.  If not, see <http://www.gnu.org/licenses/>
 * 
 * 
 * Copyright (C) 2013, Dominik Rueß; info@dominik-ruess.de
 **********************************************************************/

#ifndef VERSION_PIVOT_H
#define VERSION_PIVOT_H

#include "versioning.h"
#include "patchnumber.h"

// include version numbers of required modules
#include "version_module_misc.h"
#include "version_module_flowlayout.h"
#include "version_module_imageinfo.h"
#include "version_module_imagepreview.h"
#include "version_module_imageviewer.h"
#include "version_module_progressdialog.h"
#include "version_module_randomimageframe.h"
#include "version_module_thumbnailcache.h"

template<int major, int minor, int patch>
struct VersionNumberPivot : public VersionNumber<major, minor, patch>
{
    void checkRequirements() const
    {
        version_module_misc.checkCompatibility<1, 1> ();
        version_module_flowlayout.checkCompatibility<0, 1> ();
        version_module_imageinfo.checkCompatibility<0, 1> ();
        version_module_imagepreview.checkCompatibility<0, 1> ();
        version_module_imageviewer.checkCompatibility<0, 1> ();
        version_module_imageviewer.checkCompatibility<0, 1> ();
        version_module_progressdialog.checkCompatibility<0, 1> ();
        version_module_randomimageframe.checkCompatibility<0, 1> ();
        version_module_thumbnailcache.checkCompatibility<0, 1> ();
    }
};

extern VersionNumberPivot<0, 2, DR_PATCH_NUMBER> version_pivot;

#endif // VERSION_PIVOT_H
