/***********************************************************************
 * This file is part of pivot.
 *
 * pivot is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * pivot is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with pivot.  If not, see <http://www.gnu.org/licenses/>
 * 
 * 
 * Copyright (C) 2013, Dominik Rueß; info@dominik-ruess.de
 **********************************************************************/

#ifndef VIEWDELEGATE_H
#define VIEWDELEGATE_H

#include <imageviewdelegate.h>
#include "imagedataextended.h"

#include "eventselectionassistant.h"

#define DELEGATE_DATE_COLUMN 4
#define DELEGATE_EVENT_COLUMN 3

class ViewDelegate : public ImageViewDelegate
{
    Q_OBJECT
public:
    explicit ViewDelegate(QWidget *parent = 0);


    QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option,
                               const QModelIndex &index) const;
    void setEditorData(QWidget *editor, const QModelIndex &index) const;
    void setModelData(QWidget *editor, QAbstractItemModel *model,
                      const QModelIndex &index) const;

    void updateEditorGeometry(QWidget *editor,
        const QStyleOptionViewItem &option, const QModelIndex &index) const;

    QSize sizeHint ( const QStyleOptionViewItem & option, const QModelIndex & index ) const;
    void paint ( QPainter * painter, const QStyleOptionViewItem & option, const QModelIndex & index ) const;

    void setAlbums(const QVector<PhotoAlbum>& albums) { _albums = albums; }

    void setUseComments(const bool use) { _useComments = use; }

public slots:
    void showInfo();

private:
    QVector<PhotoAlbum> _albums;
    bool _useComments;

    bool _infoHasBeenShown;
};

#endif // IMAGEVIEWDELEGATE_H
